//==============================================================================
//
//    lossyWAV: Added noise WAV bit reduction method by David Robinson;
//              Noise shaping coefficients by Sebastian Gesemann;
//
//    Copyright (C) 2007-2011 Nick Currie, Copyleft.
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
//    Contact: lossywav <at> hotmail <dot> co <dot> uk
//
//==============================================================================
//    by Tyge Lvset (tycho), Aug. 2012
//==============================================================================

#ifndef nSupport_h_
#define nSupport_h_

#include <sstream>
#include <iomanip>
#include <iostream>
#include <fstream>

// DELPHI EMULATION

template <typename T, int Low, int High> struct range_array
{
	int low() const { return Low; }
	int high() const { return High; }
	size_t size() const { return High - Low + 1; }

	T& operator[](int index) { return value[index - Low]; }
	const T& operator[](int index) const { return value[index - Low]; }

	T value[High - Low + 1];
};

typedef unsigned char* PByte;

inline int nround(double val)  // should return int64_t? // TY
{
	return int(val > 0.0 ? val + 0.5 : val - 0.5);
}

inline std::string IntToStr(int number)
{
	std::ostringstream ss;
	ss << number;
	return ss.str();
}

enum StringFormatType { ffFixed };
inline std::string floattostrf(double number, StringFormatType /*fixed*/, int /*prec*/, int digits)
{
	std::ostringstream ss;
    ss << std::fixed << std::setprecision(digits) << std::setfill('0') << std::left << number;
	return ss.str();
}

extern std::ostream& ErrOutput;
extern std::ofstream LogOutput;
extern int ioresult;
extern int ExitCode;

inline bool DirectoryExists(std::string dir_name)
{
    return true;
}

inline bool FileExists(std::string file_name)
{
	std::fstream filetest(file_name.c_str(), std::ios_base::in | std::ios_base::binary);
	if (filetest.is_open())
	{
		filetest.close();
		return true;
	}
	return false;
}

#endif
